<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetProductByProductIdRequest' => '\\StructType\\GetProductByProductIdRequest',
            'GetProductByProductIdResponse' => '\\StructType\\GetProductByProductIdResponse',
            'GetProductBySellerCodeRequest' => '\\StructType\\GetProductBySellerCodeRequest',
            'GetProductBySellerCodeResponse' => '\\StructType\\GetProductBySellerCodeResponse',
            'GetProductListRequest' => '\\StructType\\GetProductListRequest',
            'GetProductListResponse' => '\\StructType\\GetProductListResponse',
            'SearchProductsRequest' => '\\StructType\\SearchProductsRequest',
            'SearchProductsResponse' => '\\StructType\\SearchProductsResponse',
            'UpdateProductPriceByIdRequest' => '\\StructType\\UpdateProductPriceByIdRequest',
            'UpdateProductPriceByIdResponse' => '\\StructType\\UpdateProductPriceByIdResponse',
            'UpdateProductPriceBySellerCodeRequest' => '\\StructType\\UpdateProductPriceBySellerCodeRequest',
            'UpdateProductPriceBySellerCodeResponse' => '\\StructType\\UpdateProductPriceBySellerCodeResponse',
            'DeleteProductByIdRequest' => '\\StructType\\DeleteProductByIdRequest',
            'DeleteProductByIdResponse' => '\\StructType\\DeleteProductByIdResponse',
            'DeleteProductBySellerCodeRequest' => '\\StructType\\DeleteProductBySellerCodeRequest',
            'DeleteProductBySellerCodeResponse' => '\\StructType\\DeleteProductBySellerCodeResponse',
            'SaveProductResponse' => '\\StructType\\SaveProductResponse',
            'SaveProductRequest' => '\\StructType\\SaveProductRequest',
            'UpdateProductBasicRequest' => '\\StructType\\UpdateProductBasicRequest',
            'UpdateProductBasicResponse' => '\\StructType\\UpdateProductBasicResponse',
            'UpdateDiscountValueByProductIdRequest' => '\\StructType\\UpdateDiscountValueByProductIdRequest',
            'UpdateDiscountValueByProductIdResponse' => '\\StructType\\UpdateDiscountValueByProductIdResponse',
            'UpdateDiscountValueBySellerCodeRequest' => '\\StructType\\UpdateDiscountValueBySellerCodeRequest',
            'UpdateDiscountValueBySellerCodeResponse' => '\\StructType\\UpdateDiscountValueBySellerCodeResponse',
            'GetProductQuestionListRequest' => '\\StructType\\GetProductQuestionListRequest',
            'GetProductQuestionListResponse' => '\\StructType\\GetProductQuestionListResponse',
            'GetProductQuestionDetailRequest' => '\\StructType\\GetProductQuestionDetailRequest',
            'GetProductQuestionDetailResponse' => '\\StructType\\GetProductQuestionDetailResponse',
            'SaveProductAnswerRequest' => '\\StructType\\SaveProductAnswerRequest',
            'SaveProductAnswerResponse' => '\\StructType\\SaveProductAnswerResponse',
            'AdaptUnificationProductsRequest' => '\\StructType\\AdaptUnificationProductsRequest',
            'AdaptUnificationProductsResponse' => '\\StructType\\AdaptUnificationProductsResponse',
            'Product' => '\\StructType\\Product',
            'SpecialProductInfoList' => '\\StructType\\SpecialProductInfoList',
            'ProductBasicList' => '\\StructType\\ProductBasicList',
            'ProductRequest' => '\\StructType\\ProductRequest',
            'ProductBasic' => '\\StructType\\ProductBasic',
            'ProductData' => '\\StructType\\ProductData',
            'ProductQuestion' => '\\StructType\\ProductQuestion',
            'ProductQuestionList' => '\\StructType\\ProductQuestionList',
            'ProductQuestionDetail' => '\\StructType\\ProductQuestionDetail',
            'Category' => '\\StructType\\Category',
            'CategoryRequest' => '\\StructType\\CategoryRequest',
            'SpecialProductInfoApiModel' => '\\StructType\\SpecialProductInfoApiModel',
            'ProductImage' => '\\StructType\\ProductImage',
            'ProductImageList' => '\\StructType\\ProductImageList',
            'ProductSku' => '\\StructType\\ProductSku',
            'ProductSkuBasic' => '\\StructType\\ProductSkuBasic',
            'ProductSkuBasicRequest' => '\\StructType\\ProductSkuBasicRequest',
            'ProductUpdateSkuBasicRequest' => '\\StructType\\ProductUpdateSkuBasicRequest',
            'ProductSkuBasicItemList' => '\\StructType\\ProductSkuBasicItemList',
            'ProductSkuBasicRequestItemList' => '\\StructType\\ProductSkuBasicRequestItemList',
            'ProductUpdateSkuBasicRequestItemList' => '\\StructType\\ProductUpdateSkuBasicRequestItemList',
            'ProductSkuItemList' => '\\StructType\\ProductSkuItemList',
            'ProductSkuRequest' => '\\StructType\\ProductSkuRequest',
            'StockItem' => '\\StructType\\StockItem',
            'StockItemForAddStockWithId' => '\\StructType\\StockItemForAddStockWithId',
            'StockItemForUpdateStockWithId' => '\\StructType\\StockItemForUpdateStockWithId',
            'StockItemForAddStockWithIdList' => '\\StructType\\StockItemForAddStockWithIdList',
            'StockItemForUpdateStockWithIdList' => '\\StructType\\StockItemForUpdateStockWithIdList',
            'StockItemForAddStockWithSellerStockCode' => '\\StructType\\StockItemForAddStockWithSellerStockCode',
            'StockItemForUpdateStockWithSellerStockCode' => '\\StructType\\StockItemForUpdateStockWithSellerStockCode',
            'StockItemForAddStockWithSellerStockCodeList' => '\\StructType\\StockItemForAddStockWithSellerStockCodeList',
            'StockItemForUpdateStockWithSellerStockCodeList' => '\\StructType\\StockItemForUpdateStockWithSellerStockCodeList',
            'StockItemForAddStockWithAttributes' => '\\StructType\\StockItemForAddStockWithAttributes',
            'StockItemForUpdateStockWithAttributes' => '\\StructType\\StockItemForUpdateStockWithAttributes',
            'StockItemForAddStockWithAttributesList' => '\\StructType\\StockItemForAddStockWithAttributesList',
            'StockItemForUpdateStockWithAttributesList' => '\\StructType\\StockItemForUpdateStockWithAttributesList',
            'StockAttribute' => '\\StructType\\StockAttribute',
            'StockAttributeList' => '\\StructType\\StockAttributeList',
            'StockItemList' => '\\StructType\\StockItemList',
            'StockDataWithProductId' => '\\StructType\\StockDataWithProductId',
            'ProductWithId' => '\\StructType\\ProductWithId',
            'StockDataWithProductSellerCode' => '\\StructType\\StockDataWithProductSellerCode',
            'ProductWithIdAndStockId' => '\\StructType\\ProductWithIdAndStockId',
            'ProductWithIdAndStockSellerCode' => '\\StructType\\ProductWithIdAndStockSellerCode',
            'ProductWithIdAndStockAttributes' => '\\StructType\\ProductWithIdAndStockAttributes',
            'ProductWithIdAndStockAttributesForUpdate' => '\\StructType\\ProductWithIdAndStockAttributesForUpdate',
            'ProductWithSellerCode' => '\\StructType\\ProductWithSellerCode',
            'ProductAttribute' => '\\StructType\\ProductAttribute',
            'ProductAttributeRequest' => '\\StructType\\ProductAttributeRequest',
            'ProductAttributeRequestList' => '\\StructType\\ProductAttributeRequestList',
            'ProductAttributeList' => '\\StructType\\ProductAttributeList',
            'ProductDiscount' => '\\StructType\\ProductDiscount',
            'ProductDiscountRequest' => '\\StructType\\ProductDiscountRequest',
            'ProductSearch' => '\\StructType\\ProductSearch',
            'ProductQuestionSearch' => '\\StructType\\ProductQuestionSearch',
            'DateRange' => '\\StructType\\DateRange',
            'ProductSkuList' => '\\StructType\\ProductSkuList',
            'ProductSkuRequestList' => '\\StructType\\ProductSkuRequestList',
            'SellerProductDiscount' => '\\StructType\\SellerProductDiscount',
            'BaseRequest' => '\\StructType\\BaseRequest',
            'Authentication' => '\\StructType\\Authentication',
            'PagingData' => '\\StructType\\PagingData',
            'RequestPagingData' => '\\StructType\\RequestPagingData',
            'BaseResponse' => '\\StructType\\BaseResponse',
            'ResultInfo' => '\\StructType\\ResultInfo',
        );
    }
}
