<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProductDiscount StructType
 * @subpackage Structs
 */
class ProductDiscount extends AbstractStructBase
{
    /**
     * The startDate
     * @var string
     */
    public $startDate;
    /**
     * The endDate
     * @var string
     */
    public $endDate;
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The value
     * @var string
     */
    public $value;
    /**
     * The maxPurchaseCount
     * @var string
     */
    public $maxPurchaseCount;
    /**
     * Constructor method for ProductDiscount
     * @uses ProductDiscount::setStartDate()
     * @uses ProductDiscount::setEndDate()
     * @uses ProductDiscount::setType()
     * @uses ProductDiscount::setValue()
     * @uses ProductDiscount::setMaxPurchaseCount()
     * @param string $startDate
     * @param string $endDate
     * @param string $type
     * @param string $value
     * @param string $maxPurchaseCount
     */
    public function __construct($startDate = null, $endDate = null, $type = null, $value = null, $maxPurchaseCount = null)
    {
        $this
            ->setStartDate($startDate)
            ->setEndDate($endDate)
            ->setType($type)
            ->setValue($value)
            ->setMaxPurchaseCount($maxPurchaseCount);
    }
    /**
     * Get startDate value
     * @return string|null
     */
    public function getStartDate()
    {
        return $this->startDate;
    }
    /**
     * Set startDate value
     * @param string $startDate
     * @return \StructType\ProductDiscount
     */
    public function setStartDate($startDate = null)
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($startDate)), __LINE__);
        }
        $this->startDate = $startDate;
        return $this;
    }
    /**
     * Get endDate value
     * @return string|null
     */
    public function getEndDate()
    {
        return $this->endDate;
    }
    /**
     * Set endDate value
     * @param string $endDate
     * @return \StructType\ProductDiscount
     */
    public function setEndDate($endDate = null)
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($endDate)), __LINE__);
        }
        $this->endDate = $endDate;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\ProductDiscount
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get value value
     * @return string|null
     */
    public function getValue()
    {
        return $this->value;
    }
    /**
     * Set value value
     * @param string $value
     * @return \StructType\ProductDiscount
     */
    public function setValue($value = null)
    {
        // validation for constraint: string
        if (!is_null($value) && !is_string($value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($value)), __LINE__);
        }
        $this->value = $value;
        return $this;
    }
    /**
     * Get maxPurchaseCount value
     * @return string|null
     */
    public function getMaxPurchaseCount()
    {
        return $this->maxPurchaseCount;
    }
    /**
     * Set maxPurchaseCount value
     * @param string $maxPurchaseCount
     * @return \StructType\ProductDiscount
     */
    public function setMaxPurchaseCount($maxPurchaseCount = null)
    {
        // validation for constraint: string
        if (!is_null($maxPurchaseCount) && !is_string($maxPurchaseCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maxPurchaseCount)), __LINE__);
        }
        $this->maxPurchaseCount = $maxPurchaseCount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProductDiscount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
