<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StockItemForUpdateStockWithId StructType
 * @subpackage Structs
 */
class StockItemForUpdateStockWithId extends AbstractStructBase
{
    /**
     * The id
     * @var int
     */
    public $id;
    /**
     * The quantity
     * @var int
     */
    public $quantity;
    /**
     * The version
     * @var int
     */
    public $version;
    /**
     * The delist
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var bool
     */
    public $delist;
    /**
     * Constructor method for StockItemForUpdateStockWithId
     * @uses StockItemForUpdateStockWithId::setId()
     * @uses StockItemForUpdateStockWithId::setQuantity()
     * @uses StockItemForUpdateStockWithId::setVersion()
     * @uses StockItemForUpdateStockWithId::setDelist()
     * @param int $id
     * @param int $quantity
     * @param int $version
     * @param bool $delist
     */
    public function __construct($id = null, $quantity = null, $version = null, $delist = null)
    {
        $this
            ->setId($id)
            ->setQuantity($quantity)
            ->setVersion($version)
            ->setDelist($delist);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \StructType\StockItemForUpdateStockWithId
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get quantity value
     * @return int|null
     */
    public function getQuantity()
    {
        return $this->quantity;
    }
    /**
     * Set quantity value
     * @param int $quantity
     * @return \StructType\StockItemForUpdateStockWithId
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: int
        if (!is_null($quantity) && !is_numeric($quantity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($quantity)), __LINE__);
        }
        $this->quantity = $quantity;
        return $this;
    }
    /**
     * Get version value
     * @return int|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param int $version
     * @return \StructType\StockItemForUpdateStockWithId
     */
    public function setVersion($version = null)
    {
        // validation for constraint: int
        if (!is_null($version) && !is_numeric($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
    /**
     * Get delist value
     * @return bool|null
     */
    public function getDelist()
    {
        return $this->delist;
    }
    /**
     * Set delist value
     * @param bool $delist
     * @return \StructType\StockItemForUpdateStockWithId
     */
    public function setDelist($delist = null)
    {
        // validation for constraint: boolean
        if (!is_null($delist) && !is_bool($delist)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($delist)), __LINE__);
        }
        $this->delist = $delist;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StockItemForUpdateStockWithId
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
