<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StockItemForUpdateStockWithIdList StructType
 * @subpackage Structs
 */
class StockItemForUpdateStockWithIdList extends AbstractStructBase
{
    /**
     * The stockItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\StockItemForUpdateStockWithId[]
     */
    public $stockItem;
    /**
     * Constructor method for StockItemForUpdateStockWithIdList
     * @uses StockItemForUpdateStockWithIdList::setStockItem()
     * @param \StructType\StockItemForUpdateStockWithId[] $stockItem
     */
    public function __construct(array $stockItem = array())
    {
        $this
            ->setStockItem($stockItem);
    }
    /**
     * Get stockItem value
     * @return \StructType\StockItemForUpdateStockWithId[]|null
     */
    public function getStockItem()
    {
        return $this->stockItem;
    }
    /**
     * Set stockItem value
     * @throws \InvalidArgumentException
     * @param \StructType\StockItemForUpdateStockWithId[] $stockItem
     * @return \StructType\StockItemForUpdateStockWithIdList
     */
    public function setStockItem(array $stockItem = array())
    {
        foreach ($stockItem as $stockItemForUpdateStockWithIdListStockItemItem) {
            // validation for constraint: itemType
            if (!$stockItemForUpdateStockWithIdListStockItemItem instanceof \StructType\StockItemForUpdateStockWithId) {
                throw new \InvalidArgumentException(sprintf('The stockItem property can only contain items of \StructType\StockItemForUpdateStockWithId, "%s" given', is_object($stockItemForUpdateStockWithIdListStockItemItem) ? get_class($stockItemForUpdateStockWithIdListStockItemItem) : gettype($stockItemForUpdateStockWithIdListStockItemItem)), __LINE__);
            }
        }
        $this->stockItem = $stockItem;
        return $this;
    }
    /**
     * Add item to stockItem value
     * @throws \InvalidArgumentException
     * @param \StructType\StockItemForUpdateStockWithId $item
     * @return \StructType\StockItemForUpdateStockWithIdList
     */
    public function addToStockItem(\StructType\StockItemForUpdateStockWithId $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StockItemForUpdateStockWithId) {
            throw new \InvalidArgumentException(sprintf('The stockItem property can only contain items of \StructType\StockItemForUpdateStockWithId, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->stockItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StockItemForUpdateStockWithIdList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
